#ifndef R2C2_3D_TRACK_H_
#define R2C2_3D_TRACK_H_

#include <list>
#include <sigc++/trackable.h>
#include <msp/gl/matrix.h>
#include <msp/gl/objectinstance.h>
#include "libr2c2/track.h"
#include "libr2c2/trackpart.h"
#include "object.h"

namespace R2C2 {

class Endpoint3D;
class Path3D;
class TrackType3D;

class Track3D: public Object3D, public Msp::GL::ObjectInstance
{
private:
	Track &track;
	const TrackType3D &type;
	std::vector<Endpoint3D *> endpoints;

public:
	Track3D(Layout3D &, Track &);
	~Track3D();

	Layout3D &get_layout() const { return layout; }
	Track &get_track() const { return track; }
	const TrackType3D &get_type() const { return type; }

	virtual Vector get_node() const;
	virtual bool is_visible() const { return true; }

	virtual void setup_render(Msp::GL::Renderer &, const Msp::GL::Tag &) const;
private:
	void link_changed(unsigned, Track *);
};

} // namespace R2C2

#endif
