#ifndef EXTENDTOOL_H_
#define EXTENDTOOL_H_

#include <map>
#include <set>
#include <vector>
#include "libr2c2/object.h"
#include "libr2c2/trackiter.h"
#include "tool.h"

class ExtendTool: public Tool
{
private:
	std::map<float, const R2C2::TrackType *> types_by_length;
	unsigned max_preference;
	std::vector<R2C2::TrackIter> unlinked_endpoints;
	std::vector<R2C2::Track *> extend_tracks;

public:
	ExtendTool(Designer &, Msp::Input::Keyboard &, Msp::Input::Mouse &, const std::set<R2C2::Object *> &);
	virtual ~ExtendTool();

	void connect();

private:
	virtual void pointer_motion();
	virtual void finish();

	std::vector<R2C2::Track *> create_straight(const R2C2::Vector &, const R2C2::Angle &, float, float);

public:
	virtual void update_selection(Selection &) const;
};

#endif
