#ifndef SELECTIONWRAP_H_
#define SELECTIONWRAP_H_

#include <msp/gl/mesh.h>
#include <msp/gl/renderable.h>
#include "libr2c2/object.h"
#include "3d/layout.h"

class Designer;
class Selection;

class SelectionWrap: public Msp::GL::Renderable
{
private:
	struct Wrap
	{
		R2C2::Object *object;
		const Msp::GL::Mesh *mesh;
	};

	Selection &selection;
	std::map<const R2C2::ObjectType *, Msp::GL::Mesh *> meshes;
	std::map<const R2C2::Object *, Msp::GL::Mesh *> transient_meshes;
	std::list<Wrap> wraps;

public:
	SelectionWrap(Selection &);
	~SelectionWrap();

	virtual void render(Msp::GL::Renderer &, const Msp::GL::Tag &) const;

private:
	void selection_changed();
	const Msp::GL::Mesh &get_mesh(const R2C2::Object &);
};

#endif
