#include <msp/core/maputils.h>
#include <msp/net/inet.h>
#include <msp/net/resolve.h>
#include "connectdialog.h"

using namespace Msp;
using namespace R2C2;

ConnectDialog::ConnectDialog(Client &c):
	client(c)
{
	Loader::WidgetMap widgets;
	DataFile::load(*this, "data/remote/connectdialog.ui", widgets);

	ent_host = dynamic_cast<GLtk::Entry *>(get_item(widgets, "ent_host"));
	ent_port = dynamic_cast<GLtk::Entry *>(get_item(widgets, "ent_port"));
	ent_port->set_text("8315");
}

void ConnectDialog::on_response(int)
{
	Net::SockAddr *addr = Net::resolve(ent_host->get_text(), ent_port->get_text(), Net::INET);
	client.connect(*addr);
	delete addr;
}
